package tests;

import models.Singleton1;

/**
 * Test class for {@link Singleton1}<br>
 * 
 * <ul>
 * <li>Construct two {@link Singleton1} instances/objects using the
 * {@link Singleton1#instance()} method</li>
 * <li>Set the {@link Singleton1#data} value of the first instance and print information
 * concerning both objects to the screen</li>
 * <li>Check - on the screen output - that the references and values for both
 * objects are the same</li>
 * </ul>
 * <br>
 * EXPECTED (TYPICAL) OUTPUT
 * 
 * <pre>
 * First singleton1: models.Singleton1@70dea4e
 * First singleton1 data value =  34
 * Second singleton1: models.Singleton1@70dea4e
 * Second singleton1 data value =  34
 * 
 *  CHECK - on the previous output - that the references and values for both objects are the same
 * </pre>
 * 
 * @author J Paul Gibson
 */
public class TestSingleton1 {

	public static void main(String args[]) {

		final int TEST_DATA_VALUE = 34; // An arbitrary value for testing
										// purposes

		// Construct 2 singleton1 objects using the instance method
		Singleton1 s1a = Singleton1.instance();
		Singleton1 s1b = Singleton1.instance();

		// Set the data value.
		s1a.setData(TEST_DATA_VALUE);

		// Print information concerning both objects to the screen
		System.out.println("First singleton1: " + s1a);
		System.out.println("First singleton1 data value =  " + s1a.getData());
		System.out.println("Second singleton1: " + s1b);
		System.out.println("Second singleton1 data value =  " + s1b.getData());

		// Check - on the screen output - that the references and values for
		// both objects are the same
		System.out
				.println("\n CHECK - on the previous output - that the references and values for both objects are the same");
	}
}
