package tests;

import models.Singleton2;

/**
 * Test class for {@link Singleton2}<br>
 * 
 * <ul>
 * <li>Construct two {@link Singleton2} instances/objects using the
 * {@link Singleton2#uniqueinstance} attribute</li>
 * <li>Set the {@link Singleton2#data} value of the first instance and print information
 * concerning both objects to the screen</li>
 * <li>Check - on the screen output - that the references and values for both
 * objects are the same</li>
 * </ul>
 * <br>
 * EXPECTED (TYPICAL) OUTPUT
 * 
 * <pre>
 * First singleton2: models.Singleton1@70dea4e
 * First singleton2 data value =  34
 * Second singleton2: models.Singleton1@70dea4e
 * Second singleton2 data value =  34
 * 
 *  CHECK - on the previous output - that the references and values for both objects are the same
 * </pre>
 * 
 * @author J Paul Gibson
 */
public class TestSingleton2 {

	public static void main(String args[]) {

		final int TEST_DATA_VALUE = 34; // An arbitrary value for testing
										// purposes

		// Construct 2 singleton2 objects using the instance method
		Singleton2 s2a = Singleton2.uniqueinstance;
		Singleton2 s2b = Singleton2.uniqueinstance;

		// Set the data value.
		s2a.setData(TEST_DATA_VALUE);

		// Print information concerning both objects to the screen
		System.out.println("First singleton2: " + s2a);
		System.out.println("First singleton2 data value =  " + s2a.getData());
		System.out.println("Second singleton2: " + s2b);
		System.out.println("Second singleton2 data value =  " + s2b.getData());

		// Check - on the screen output - that the references and values for
		// both objects are the same
		System.out
				.println("\n CHECK - on the previous output - that the references and values for both objects are the same");
	}
}
